<?php
if ( !defined( 'BASEPATH' ) ) exit( 'No direct script access allowed' );

class Router {
	
	/**
	 * Holder for the response format requested
	 *
	 * @var		string
	 * @access	private
	 */
	private static $_format		= '';
	
	/**
	 * Method used to parse the url to retrieve the requested response format
	 *
	 * @return	void
	 * @access	public
	 */
	public function route() {
		// Check if there are get parameters passed (this will only work on PHP 5.3.0+)
		$request				= strstr( $_SERVER['REQUEST_URI'], '?', true );
		if ( !$request ) {
			// There were no parameters, use the full URI
			$request			= $_SERVER['REQUEST_URI'];
		}
		// Since we remove the GET parameters the requested response type will be the only thing after the '.' character
		$parts					= explode( '.', $request );
		self::$_format			= $parts[ sizeof($parts) - 1 ];
		
		// Is the response a know value? If not let the application handle the request without interfering
		if ( self::$_format == 'json' || self::$_format == 'xml' || self::$_format == 'rss' || self::$_format == 'atom' ) {
			// Reset the URI for the CodeIgniter Router to handle it, remove the requested format along with the '.' char
			$_SERVER['REQUEST_URI']	= substr( $request, 0, ( strlen( $request ) - strlen( self::$_format ) - 1 ) );
		} else {
			self::$_format	= '';
		}
	}
	
	/**
	 * Method used to set the requested response type for the whole application to use it
	 *
	 * @return	void
	 * @access	public
	 */
	public function config() {
		// Retrieve the CodeIgniter instance and set a config option with the response format requested
		$CI		=& get_instance();
		$CI->config->set_item( 'response_format', self::$_format );
	}
}